import { SuggestionResult } from './suggest';
import { Trie } from './Trie';
import * as Rx from 'rxjs/Rx';
import { IterableLike } from '../util/IterableLike';
export interface SpellingDictionary {
    has(word: string): boolean;
    suggest(word: string, numSuggestions?: number): SuggestionResult[];
    size: number;
}
export declare class SpellingDictionaryInstance implements SpellingDictionary {
    readonly words: Set<string>;
    private _trie;
    constructor(words: Set<string>);
    readonly trie: Trie;
    has(word: string): boolean;
    suggest(word: string, numSuggestions?: number): SuggestionResult[];
    readonly size: number;
}
export declare function createSpellingDictionary(wordList: string[] | IterableLike<string>): SpellingDictionary;
export declare function createSpellingDictionaryRx(words: Rx.Observable<string>): Promise<SpellingDictionary>;
