"use strict";
function uniqueFilterFnGenerator(extractFn) {
    const values = new Set();
    const extractor = extractFn || (a => a);
    return (v) => {
        const vv = extractor(v);
        const ret = !values.has(vv);
        values.add(vv);
        return ret;
    };
}
exports.uniqueFilterFnGenerator = uniqueFilterFnGenerator;
function unique(src) {
    return [...(new Set(src))];
}
exports.unique = unique;
//# sourceMappingURL=util.js.map